#include "stdafx.h"
#include <Windows.h>
#include "MyString.h"
#include "MyRegistry.h"
#include <conio.h>

CMyString temp;

void AddBool(BOOL res)
{
	if (res) temp<<" = Vrai";
	else temp<<" = Faux";
}

void AddResult(BOOL res)
{
	if (res) temp<<" = Ok";
	else temp<<" = Erreur";
}

void PrintTemp()
{
	printf("%s",(char *)temp);
	fflush(stdin);
}

CMyRegistry reg;

#include "utilsDebug.h"

void AddLastError()
{
	char *res = MyMessageError(reg.GetLastError());
	if (res) temp<<"! Erreur = "<<res;
}

int _tmain(int argc, _TCHAR* argv[])
{
	CMyString keyName="";
	CMyString str;
	char value[1024],value2[1024];
	BOOL res;

	while (1)
	{
		temp="";
		reg.GetKeyName(keyName); // utils dans le cas de ..\ ou \myRegistre
		temp<<  "Key: ["<<keyName<<"]"; AddResult(reg.TestKey());
		temp<<"\n'o':  Open                     'c':  Create\n";
		temp<<  "'d':  DeleteKey , DeleteValue  't':  TestValue\n";
		temp<<  "'g':  GetValue                 's':  SetValue\n";
		temp<<  "'e':  EnumKey , EnumValue      'a':  IsAutoCreate "; AddBool(reg.IsAutoCreate());
		temp<<"\n";
		PrintTemp();
		temp="";
		switch(getch())
		{
			case 'o': // Open
				printf("=> Open: ");
				gets(value);
				temp<<"Result";
				AddResult(reg = value);
				temp<<"\n";
				break;

			case 'c': //Create
				printf("=> Create: ");
				gets(value);
				reg.Create(value);
				break;

			case 'e': // Enum
				printf("=> Enum 'k': EnumKey , 'v': EnumValue\n");
				switch(getch())
				{
					case 'k': //EnumKey
						temp="=> EnumKey\n";
						reg.BeginEnumKey();
						while (reg.NextEnumKey(str)) temp<<"* ["<<str<<"]\n";
						break;
					case 'v': //EnumValue
						temp="=> EnumValue\n";
						reg.BeginEnumValue();
						while (reg.NextEnumValue(str)) temp<<"* ["<<str<<"]\n";
						break;
					default:
						temp<<"! Seulement touches 'k' ou 'v'\n";
				}
				break;

			case 'd': // Delete
				printf("=> Delete 'k': DeleteKey , 'v': DeleteValue\n");
				switch (getch())
				{
					case 'k': //DeleteKey
						temp<<"=> DeleteKey";
						AddResult(reg.DeleteKey());
						break;
					case 'v': //DeleteValue
						printf("=> DeleteValue: ");
						gets(value);
						temp<<"Result";
						AddResult(reg.DeleteValue(value));
						break;
					default:
						temp<<"! Seulement touches 'k' ou 'v";
				}
				temp<<"\n";
				break;

			case 'a': //IsAutoCreate
				printf("=> IsAutoCreate (switch)\n");
				reg.SetAutoCreate(!reg.IsAutoCreate());
				break;

			case 'g': //GetValue
				{
					printf("=> GetValue 's': String , 'i': Integer , 'l': Longinteger\n");
					int integer;
					long longinteger;
					switch (getch())
					{
						case 'i': 
							printf("=> GetValue, int\n");
							printf("value: ");
							gets(value);
							res = reg.GetValue(value,&integer);
							temp<<"["<<integer<<"]";
							AddResult(res);
							break;
						case 'l': 
							printf("=> GetValue, long\n");
							printf("value: ");
							gets(value);
							res = reg.GetValue(value,&longinteger);
							temp<<"["<<longinteger<<"]";
							AddResult(res);
							break;
						case 's': 
							printf("=> GetValue, string\n");
							printf("value: ");
							gets(value);
							res = reg.GetValue(value,str);
							temp<<"["<<str<<"]";
							AddResult(res);
							break;
						default:
							printf("! Seulement touches 'i' , 'l' ou 's'\n");
					}
					temp<<"\n";
				}
				break;

			case 's': //SetValue
				{
					printf("=> SetValue 's': String , 'i': Integer , 'l': Longinteger\n");
					int integer;
					long longinteger;
					switch (getch())
					{
					case 'i': 
						printf("=> SetValue, int\n");
						printf("variable: ");
						gets(value);
						printf("value: ");
						scanf("%i",&integer); 
						temp<<"Result";
						AddResult(reg.SetValue(value,integer));
						break;

					case 'l': 
						printf("=> SetValue, long\n"); 
						printf("variable: ");
						gets(value);
						printf("value: ");
						scanf("%i",&longinteger); 
						temp<<"Result";
						AddResult(reg.SetValue(value,longinteger));
						break;

					case 's': 
						printf("=> SetValue, string\n"); 
						printf("variable: ");
						gets(value);
						printf("value: ");
						gets(value2);
						temp<<"Result";
						AddResult(reg.SetValue(value,value2));
						break;
					default:
						printf("! Seulement touches 'i' , 'l' ou 's'\n");
						break;
					}
					temp<<"\n";
				}
				break;

			case 't': //TestValue
				printf("=> TestValue: ");
				gets(value);
				temp<<"Result";
				AddResult(reg.TestValue(value));
				temp<<"\n";
				break;

			default:
				temp<<"! Commande inexistante\n";
		}
		AddLastError();
		temp<<"\n";
		PrintTemp();
	}
	return 0;
}

